Package org.eclipse.cdt.core.dom.ast.cpp

# Interface ICPPASTTemplateParameter

All Superinterfaces:
  `IASTNode`

All Known Subinterfaces:
  `ICPPASTParameterDeclaration`, `ICPPASTSimpleTypeTemplateParameter`, `ICPPASTTemplatedTypeTemplateParameter`

public interface ICPPASTTemplateParameter extends IASTNode
Base interface for all template parameters.

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ICPPASTTemplateParameter[]`
`EMPTY_TEMPLATEPARAMETER_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`ICPPASTTemplateParameter`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`ICPPASTTemplateParameter`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`boolean`
`isParameterPack()`
Returns whether this template parameter is a parameter pack.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Field Details

### EMPTY_TEMPLATEPARAMETER_ARRAY

static final ICPPASTTemplateParameter[] EMPTY_TEMPLATEPARAMETER_ARRAY

## Method Details

### isParameterPack

boolean isParameterPack()
Returns whether this template parameter is a parameter pack.

Since:
  5.2

### copy

ICPPASTTemplateParameter copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

### copy

ICPPASTTemplateParameter copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3